//+-----------------------------------------------------------------------------------------------------+
// e_ChopPieces.mq4                                                                  
//+-----------------------------------------------------------------------------------------------------+
#property copyright "Copyright  2008, BiViSi Corp."
#property link      "riderfin@bk.ru"
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   //---- input out parameters
   extern string nameEA = "ChopPieces"; //     Comment ,  
   extern int DopMN=1000; //    MagicNumber
   //--               
   extern int PauseBeforeTrade = 11; //     ( )
   extern int MaxWaiting_sec = 120; //max     
   //----   
   extern double Dolya = 0.5;      //       
   extern int Down =50;            //        
   extern double Lot = 0.1;        //    
   // Money Managment
   extern bool LotsMeneg = false;  // :  -  
   double Lots;                    //**********
   //--        
   extern int DayTrades = 0;  // 0 -     1....5 - ...
   extern int BeginOpen = 2; // 1-20   //  
   extern int EndOpen = 20; // 2-21     //   
   extern int TimeTrade = 22; //       0 -    
   //--- ,      
   extern int Profit = 10; //       ,     
   extern int TakeProfit = 0;
   extern int StopLoss = 30; 
   extern int Step= 20; //   
   //---- Variables 
   double ArrayLevelTrades[360][2]; //    
   int ArrayBuyTrades[360][20];   //    buy  
   int ArraySellTrades[360][20];   //    sell  
   double ArrayPipsTrades [360];//    
   int ArrayCloseTrades [360]; //     
   double Delta, LO, SL, TP, st, st3, spr; 
   int Spread;   
   datetime LastTimeOpenCalc, LastTimeCloseCalc;
   int MN=0;
   int OpenBuy=0, OpenSell=0, OpenSellStop, OpenSellLimit, OpenBuyStop, OpenBuyLimit;
   datetime prevtime;
   
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
   double DeltaTakeStopMin, DeltaFreezeLevel;
   Spread = MarketInfo (Symbol(), MODE_SPREAD);
   spr=Spread*Point;
   DeltaTakeStopMin = MarketInfo (Symbol(), MODE_STOPLEVEL)*Point;
   DeltaFreezeLevel = MarketInfo (Symbol(), MODE_FREEZELEVEL)*Point;
   if (DeltaTakeStopMin>=DeltaFreezeLevel) Delta=DeltaTakeStopMin;
   else Delta=DeltaFreezeLevel;
   st=Step*Point; st3=st/3;
   
   //ArrayInitialize(ArrayLevelTrades,0.0);
   //ArrayInitialize(ArrayBuyTrades,0);ArrayInitialize(ArraySellTrades,0);
   //ArrayInitialize(ArrayPipsTrades,0.0);ArrayInitialize(ArrayCloseTrades,0);

   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit(){return(0);}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()
{
   
   // if (prevtime==Time[0]) return; else prevtime=Time[0];
   
   // ,            
   MN=DayOfYear();
   int dw=DayOfWeek();
   int x, y, dt, ht, omn;
   ArrayInitialize(ArrayPipsTrades,0.0);
   ArrayInitialize(ArrayBuyTrades,0);ArrayInitialize(ArraySellTrades,0);
   //           
   int total=OrdersTotal();
   for(x=total; x>=0; x--)
      {
      if (!IsTesting() && !IsOptimization() && OrderComment() != nameEA) continue;
      if (!OrderSelect(x, SELECT_BY_POS, MODE_TRADES))continue;
      omn = OrderMagicNumber()-DopMN;
      if (ArrayCloseTrades[omn] != 0) continue;
      //              
      double oop;
      if (OrderType()==OP_BUY || OrderType()==OP_BUYSTOP) oop=NormalizeDouble(OrderOpenPrice(),Digits)-spr;      
      if (OrderType()==OP_SELL || OrderType()==OP_SELLSTOP) oop=NormalizeDouble(OrderOpenPrice(),Digits);      
      for (y=1; y<20; y++)
         {
         double lo=ArrayLevelTrades[MN][1]+st*(y-10);
         double loh=lo+st3, lol=lo-st3;           
         if ((OrderType()==OP_BUY || OrderType()==OP_BUYSTOP) && oop<=loh && oop>=lol) 
            {
            ArrayBuyTrades[MN][y]=1;
            break;
            }
         if ((OrderType()==OP_SELL || OrderType()==OP_SELLSTOP) && oop<=loh && oop>=lol) 
            {
            ArraySellTrades[MN][y]=1;
            break;
            }
         }
      //      ( )
      dt=MN-omn;
      if (dt==0) ht=Hour() - BeginOpen;
      else ht=Hour() + (dt-1)*24 + (24-BeginOpen);
      //    -     
      if ((dt>=3 && dw==1) || (dt>=4 && dw==2) || (dt>=5 && dw==3) || (dt>=6 && dw==4) || (dt>=7 && dw==5)) ht-=48;
      if (ht>=TimeTrade) {ArrayCloseTrades[omn] = 1; continue;}
      //      
      if (OrderType()==OP_BUY) ArrayPipsTrades[omn]+=(Bid-OrderOpenPrice());
      if (OrderType()==OP_SELL) ArrayPipsTrades[omn]+=(OrderOpenPrice()-Ask);
      }

   //        
   total=OrdersHistoryTotal();
   for(x=total; x>=0; x--)
      {
      if (!IsTesting() && !IsOptimization() && OrderMagicNumber() != (MN+DopMN)) continue;
      if (!OrderSelect(x, SELECT_BY_POS, MODE_HISTORY))continue;
      omn = OrderMagicNumber()-DopMN;
      //      
      if (OrderType()==OP_BUY) ArrayPipsTrades[omn]+=(OrderClosePrice()-OrderOpenPrice());
      if (OrderType()==OP_SELL) ArrayPipsTrades[omn]+=(OrderOpenPrice()-OrderClosePrice());
      }
   //   
   total=OrdersTotal();
   for(x=total; x>=0; x--)
      {
      if (!IsTesting() && !IsOptimization() && OrderComment() != nameEA) continue;
      if (!OrderSelect(x, SELECT_BY_POS, MODE_TRADES))continue;
      omn = OrderMagicNumber() - DopMN;
      if (ArrayPipsTrades[omn]>Profit*Point) ArrayCloseTrades[omn]=1;
      if (ArrayCloseTrades[omn] == 0) continue;
      //  
      if (OrderType()==OP_BUY || OrderType()==OP_SELL)  Close_Order ();
      if (OrderType()==OP_SELLSTOP || OrderType()==OP_SELLLIMIT || 
          OrderType()==OP_BUYSTOP || OrderType()==OP_BUYLIMIT) Del_GTC();
      }

   //  
   if (ArrayCloseTrades[MN] != 0) return;   
   //       
   if (DayTrades !=0 && DayOfWeek()!= DayTrades) return;
   if (Hour()< BeginOpen || Hour()> EndOpen) return;
   //       
   if (ArrayLevelTrades[MN][1]==0.0) ArrayLevelTrades[MN][1]= Bid;
   //  
   //       
   Lot_Calculator();
   if (Lots==0) return;
   // ...  , 
   //  
   //double st=Step*Point;

   if (ArrayLevelTrades [MN][0]<2)
      {
      /*
      if (ArrayBuyTrades[MN][10]==0) OpenBuy=1;
      if (Open_Buy_Sell()==1) {ArrayBuyTrades[MN][10]=1;ArrayLevelTrades [MN][0]++;}
      OpenBuy=0;
      if (ArraySellTrades[MN][10]==0) OpenSell=1;
      if (Open_Buy_Sell()==1) {ArraySellTrades[MN][10]=1;ArrayLevelTrades [MN][0]++;}
      OpenSell=0;
      */
      // OpenSell = Bid, Take =Open-Profit, Stop=Open+Spred+Stop            
      if (ArraySellTrades[MN][9]==0) OpenSellStop=1;
      LO = ArrayLevelTrades [MN][1]-st;                
      if (TakeProfit==0)TP=0; else TP=LO-TakeProfit*Point;
      SL = LO + (Spread+StopLoss)*Point; 
      if (OpenGTC()==1) {ArraySellTrades[MN][9]=1; ArrayLevelTrades [MN][0]++;}
      OpenSellStop=0;
      // OpenBuy=Ask, Take =Open+Profit, Stop = Open-Spred-stop 
      if (ArrayBuyTrades[MN][11]==0) OpenBuyStop=1;
      LO = ArrayLevelTrades [MN][1]+st+Spread*Point;                
      if (TakeProfit==0)TP=0; else TP=LO+TakeProfit*Point;
      SL = LO - (Spread+StopLoss)*Point; 
      if (OpenGTC()==1) {ArrayBuyTrades[MN][11]=1; ArrayLevelTrades [MN][0]++;}
      OpenBuyStop=0;
      return;
      }

   //    
   //         

/*
   Alert("Hour-", Hour());
   for (y=1; y<20; y++)
      {
      if (ArrayBuyTrades[MN][y]==0 && ArraySellTrades[MN][y]==0) continue;
      Alert ("Buy-",y,"-",ArrayBuyTrades[MN][y],"  Sell-",y,"-",ArraySellTrades[MN][y]);
      }      

   Alert ("ArrayLevelTrades-1-",ArrayLevelTrades [MN][1]);
*/
   int b, s; 
   s=MathFloor((Bid-ArrayLevelTrades [MN][1])/st)-1+10; b=s+3;      
   
//   Alert ("s-",s, "b-",b);
   
   if (ArraySellTrades[MN][s]==0)
      {
      // OpenSell = Bid, Take =Open-Profit, Stop=Open+Spred+Stop            
      OpenSellStop=1;
      LO = ArrayLevelTrades [MN][1]+st*(s-10);                
      if (TakeProfit==0)TP=0; else TP=LO-TakeProfit*Point;
      SL = LO + (Spread+StopLoss)*Point; 
      if (OpenGTC()==1) ArraySellTrades[MN][s]=1;
      OpenSellStop=0;
      }

   if (ArrayBuyTrades[MN][b]==0)
      {
      // OpenBuy=Ask, Take =Open+Profit, Stop = Open-Spred-stop 
      OpenBuyStop=1;
      LO = ArrayLevelTrades [MN][1]+st*(b-10)+Spread*Point;                
      if (TakeProfit==0)TP=0; else TP=LO+TakeProfit*Point;
      SL = LO - (Spread+StopLoss)*Point; 
      if (OpenGTC()==1) ArrayBuyTrades[MN][b]=1;
      OpenBuyStop=0;
      }

   return(0);
}

//#################################################################################
//#################################################################################
//#################################################################################
//#################################################################################
//Functions 
//#################################################################################
//#################################################################################
//#################################################################################
//#################################################################################
//+------------------------------------------------------------------
//|   
//+------------------------------------------------------------------
/*
void LevelOpenCalc ()
{
   //    
   double level=Bid; 
   //Print ("1   ", level);
   double st=Step*Point;
   for (int x=1; x<=11; x+=2)
      {
      if (x==1) ArrayLevelTrades [MN][x]=level;
      else 
         {
         ArrayLevelTrades [MN][x]=level + st*MathCeil(x/2);
         ArrayLevelTrades [MN][x-1]=level - st*MathCeil(x/2);
         //Print (x-1, "   ", ArrayLevelTrades [MN][x-1]);
         //Print (x, "   ", ArrayLevelTrades [MN][x]);
         }
      }   
   ArrayLevelTrades [MN][0]=1;
   //Print (ArrayLevelTrades [MN][0]);
}
*/
//+------------------------------------------------------------------
//|     
//+------------------------------------------------------------------
int Open_Buy_Sell ()

{
   // BUY
   // Open=Ask, Take =Open+Profit, Stop = Open-Spred-stop 
   if(OpenBuy !=0)
      {      		
      //   
      Pause();
      //   
      if (!IsTesting() && !IsOptimization( )) RefreshRates();
      if (StopLoss==0) SL=0; else SL=Bid-StopLoss*Point;
      if (TakeProfit==0)TP=0; else  TP=Ask+TakeProfit*Point;
      OrderSend(Symbol(),OP_BUY,Lots,Ask,Spread,SL,TP,nameEA,MN+DopMN,0,Blue);
      TradeIsNotBusy();
      if(GetLastError()==0) return (1);
      }
   // SELL
   // Open = Bid, Take =Open-Profit, Stop=Open+Spred+Stop
   if( OpenSell !=0)
      {      		
      //   
      Pause();
      //   
      if (!IsTesting() && !IsOptimization( )) {RefreshRates();}
      if (StopLoss==0) SL=0; else SL=Ask+StopLoss*Point; 
      if (TakeProfit==0)TP=0; else TP=Bid-TakeProfit*Point;
      OrderSend(Symbol(),OP_SELL,Lots,Bid,Spread,SL,TP,nameEA,MN+DopMN,0,Red); // 
      TradeIsNotBusy();
      if(GetLastError()==0) return(1);
      }   
   return(0);
}
//***************************************************************
//                  *****************
//***************************************************************
void Lot_Calculator ()

{
//#########################################################################################
  int Mnog; double Depo;
//#########################################################################################  
  if(AccountFreeMargin()<(AccountMargin()*0.3))
      {
      Print("We have no money");
      Lots=0;
      return; //   - 
      }
   if (LotsMeneg == false)Lots=Lot;
   if (LotsMeneg == true)                       //***************
      {                                         //***************      
      Depo = AccountBalance()/100*Dolya/Down;   //***************   
      if (Depo<=1)                              //***************      
         {                                      //***************   
         Mnog=1;                                //***************
         }                                      //***************   
      else                                      //***************
         {                                      //***************   
         Mnog=(MathFloor(Depo));                //***************
         }                                      //***************
      Lots =Lot*Mnog;                           //***************
      if (Lots>10) Lots=10;                     //***************
      }                                         //***************
}

//**************************************************************
//+------------------------------------------------------------------
//|   
//+------------------------------------------------------------------
void Close_Order ()
   {

    if(OrderType()==OP_BUY)
      {
          //   
          Pause();
          OrderClose(OrderTicket(),OrderLots(),Bid,Spread,Yellow);
          TradeIsNotBusy();
      }      
    if(OrderType()==OP_SELL)
          {
          //   
          Pause();
          OrderClose(OrderTicket(),OrderLots(),Ask,Spread,Yellow);
          TradeIsNotBusy();
      }      
   }
//**************************************************************
//+------------------------------------------------------------------
//|    
//+------------------------------------------------------------------
void Del_GTC ()
   {
    if(OrderType()==OP_BUYSTOP)
          {
          Pause();
          if (!IsTesting() && !IsOptimization( )) RefreshRates();
          if ((OrderOpenPrice()-Ask)<=Delta)return;
          OrderDelete(OrderTicket(),Yellow);
          TradeIsNotBusy();
          return;  
          }      
    if(OrderType()==OP_BUYLIMIT)
          {
          Pause();
          if (!IsTesting() && !IsOptimization( )) RefreshRates();
          if ((Ask-OrderOpenPrice())<=Delta)return;
          OrderDelete(OrderTicket(),Yellow);
          TradeIsNotBusy();
          return;  
          }      
    if(OrderType()==OP_SELLSTOP)
         {
          Pause();
          if (!IsTesting() && !IsOptimization( )) RefreshRates();
          if ((Bid-OrderOpenPrice())<=Delta) return;
          OrderDelete(OrderTicket(),Yellow);
          TradeIsNotBusy();
          return;
         }      
    if(OrderType()==OP_SELLLIMIT)
         {
          Pause();
          if (!IsTesting() && !IsOptimization( )) RefreshRates();
          if ((OrderOpenPrice()-Bid)<=Delta) return;
          OrderDelete(OrderTicket(),Yellow);
          TradeIsNotBusy();
          return;
         }      

   }
//**************************************************************
//+------------------------------------------------------------------
//|   GTC Buy-Sell STOPLIMIT
//+------------------------------------------------------------------

int OpenGTC ()
{
   // OpenBuy=Ask, Take =Open+Profit, Stop = Open-Spred-stop 
   if(OpenBuyStop !=0)
      {      		
      Pause(); //   
      if (!IsTesting() && !IsOptimization( )) RefreshRates();
      if ((LO-Ask)<=Delta) return(0);
      OrderSend(Symbol(),OP_BUYSTOP,Lots,LO,0,SL,TP,nameEA,MN+DopMN,0,Blue);   
      TradeIsNotBusy();
      return(1);
      }   
   if(OpenSellStop !=0)
      // OpenSell = Bid, Take =Open-Profit, Stop=Open+Spred+Stop
      {      		
      Pause(); //   
      if (!IsTesting() && !IsOptimization( )) RefreshRates();
      if ((Bid-LO)<=Delta) return(0);
      OrderSend(Symbol(),OP_SELLSTOP,Lots,LO,0,SL,TP,nameEA,MN+DopMN,0,Red);   
      TradeIsNotBusy();
      return(1);
      }
   if(OpenBuyLimit !=0)
      // Open=Ask, Take =Open+Profit, Stop = Open-Spred-stop 
      {      		
      Pause(); //   
      if (!IsTesting() && !IsOptimization( )) RefreshRates();
      if ((Ask-LO)<=Delta) return(0);
      OrderSend(Symbol(),OP_BUYLIMIT,Lots,LO,0,SL,TP,nameEA,MN+DopMN,0,Blue);   
      TradeIsNotBusy();
      return(1);
      }   
   if(OpenSellLimit !=0)
      // Open = Bid, Take =Open-Profit, Stop=Open+Spred+Stop
      {      		
      Pause(); //   
      if (!IsTesting() && !IsOptimization( )) RefreshRates();
      if ((LO-Bid)<=Delta) return(0);
      OrderSend(Symbol(),OP_SELLLIMIT,Lots,LO,0,SL,TP,nameEA,MN+DopMN,0,Red);   
      TradeIsNotBusy();
      return(1);
      }
}

//+------------------------------------------------------------------+

//**************************************************************
//**************************************************************
//**************************************************************
//**************************************************************
//**************************************************************
//**************************************************************
//**************************************************************
//**************************************************************
//**************************************************************
//**************************************************************


//+------------------------------------------------------------------
//|      
//+------------------------------------------------------------------

void Pause()
   {
	//          , 
   if ( TradeIsBusy()!=1 ) return;
   //     
   if ( _PauseBeforeTrade()<0)
      {
      // ,     
      TradeIsNotBusy();
      return;   
      }   
   }

/////////////////////////////////////////////////////////////////////////////////
// int TradeIsBusy( int MaxWaiting_sec = 30 )
//
//      TradeIsBusy  0  1.
//     TradeIsBusy = 1,  ,  TradeIsBusy  = 0,    .
//    TradeIsBusy  ,   .
//  :
//  1 -  .   TradeIsBusy   1
// -1 -     TradeIsBusy = 1,     (   ,  
// ,   /  , ... )
// -2 -     TradeIsBusy = 1,     (MaxWaiting_sec)
/////////////////////////////////////////////////////////////////////////////////
int TradeIsBusy()
{
	//         -    
	if ( IsTesting() || IsOptimization())  return(1);

	int _GetLastError = 0, StartWaitingTime = GetTickCount();

	//+------------------------------------------------------------------+
	//| ,   .  ,  ,  
	//+------------------------------------------------------------------+
	while( true )
	{
		//     ,  
		if ( IsStopped() ) { Print( "   !" ); return(-1); }
		//     ,    MaxWaiting_sec,   
		if ( GetTickCount() - StartWaitingTime > MaxWaiting_sec * 1000 )
		{
			Print( "   (" + MaxWaiting_sec + " .)!" );
			return(-2);
		}
		// ,   . 
		//   ,           TradeIsBusy
		if ( GlobalVariableCheck( "TradeIsBusy" ) ) break;
		else
		//  GlobalVariableCheck  FALSE,    ,     
		{
			_GetLastError = GetLastError();
			//     ,  ,  0,1     
			if ( _GetLastError != 0 )
			{
				Print( "TradeIsBusy() - GlobalVariableCheck( \"TradeIsBusy\" ) - Error #", _GetLastError );
				Sleep(100);
				continue;
			}
		}

		//   ,     ,   
		//  GlobalVariableSet > 0,     .   -
		if ( GlobalVariableSet( "TradeIsBusy", 1.0 ) > 0 ) return(1);
		else
		//  GlobalVariableSet   <= 0,      
		{
			_GetLastError = GetLastError();
			//  ,  0,1     
			if ( _GetLastError != 0 )
			{
				Print( "TradeIsBusy() - GlobalVariableSet( \"TradeIsBusy\", 0.0 ) - Error #", _GetLastError );
				Sleep(100);
				continue;
			}
		}
	}

	//+---------------------------------------------------------------------------------------+
	//|       ,    .|
	//| ,  TradeIsBusy  = 0    TradeIsBusy  0  1              |
	//+---------------------------------------------------------------------------------------+
	while( true )
	{
		//     ,  
		if ( IsStopped() ) { Print( "   !" ); return(-1); }
		//     ,    MaxWaiting_sec,   
		if ( GetTickCount() - StartWaitingTime > MaxWaiting_sec * 1000 )
		{
			Print( "   (" + MaxWaiting_sec + " .)!" );
			return(-2);
		}
		//    TradeIsBusy  0  1
		//    ,   -,  1 - " "
		if ( GlobalVariableSetOnCondition( "TradeIsBusy", 1.0, 0.0 ) ) return(1);
		else
		//  ,  2 : TradeIsBusy = 1 (  ),    (   )
		{
			_GetLastError = GetLastError();
			//     ,      
			if ( _GetLastError != 0 )
			{
				Print( "TradeIsBusy() - GlobalVariableSetOnCondition ( \"TradeIsBusy\", 1.0, 0.0 ) - Error #", _GetLastError );
				continue;
			}
		}
		//   ,  TradeIsBusy = 1 (  ) -    ...
		Comment( ",     ..." );
		Sleep(1000);
		Comment("");
	}
}

/////////////////////////////////////////////////////////////////////////////////
// void TradeIsNotBusy()
//
//      TradeIsBusy = 0.
//    TradeIsBusy  ,   .
/////////////////////////////////////////////////////////////////////////////////
void TradeIsNotBusy()
{
	
	//         -    
	if ( IsTesting() || IsOptimization())  { return(0); }
  int _GetLastError;
	while( true )
	{
		//     ,  
		if ( IsStopped() ) { Print( "   !" ); return(-1); }
		//    .  = 0 (  . )
		//  GlobalVariableSet   > 0,    .   -
		if ( GlobalVariableSet( "TradeIsBusy", 0.0 ) > 0 ) return(1);
		else
		//  GlobalVariableSet   <= 0,   .  , ,    
		{
			_GetLastError = GetLastError();
			if ( _GetLastError != 0 )
				Print( "TradeIsNotBusy() - GlobalVariableSet( \"TradeIsBusy\", 0.0 ) - Error #", _GetLastError );
		}
		Sleep(100);
	}
}

/////////////////////////////////////////////////////////////////////////////////
// int _PauseBeforeTrade ()
//
//     LastTradeTime   .
//       ,   LastTradeTime + PauseBeforeTrade,  .
//    LastTradeTime  ,   .
//  :
//  1 -  
// -1 -      (   ,  ,   
//   , ... )
/////////////////////////////////////////////////////////////////////////////////
int _PauseBeforeTrade ()
{
	//       -    
	if ( IsTesting() || IsOptimization()) { return(1); }
	int _GetLastError = 0;
	int _LastTradeTime, RealPauseBeforeTrade;

	//+------------------------------------------------------------------+
	//| ,   .  ,  ,    |
	//+------------------------------------------------------------------+
	while( true )
	{
		//     ,  
		if ( IsStopped() ) { Print( "   !" ); return(-1); }

		// ,   . 
		//   ,    
		if ( GlobalVariableCheck( "LastTradeTime" ) ) break;
		else
		//  GlobalVariableCheck  FALSE,    ,     
		{
			_GetLastError = GetLastError();
			//     ,  ,  0,1     
			if ( _GetLastError != 0 )
			{
				Print( "_PauseBeforeTrade() - GlobalVariableCheck( \"LastTradeTime\" ) - Error #", _GetLastError );
				Sleep(100);
				continue;
			}
		}

		//   ,     ,   
		//  GlobalVariableSet > 0,     .   -
		if ( GlobalVariableSet( "LastTradeTime", LocalTime() ) > 0 ) return(1);
		else
		//  GlobalVariableSet   <= 0,      
		{
			_GetLastError = GetLastError();
			//  ,  0,1     
			if ( _GetLastError != 0 )
			{
				Print( "_PauseBeforeTrade() - GlobalVariableSet ( \"LastTradeTime\", ", LocalTime(), " ) - Error #", _GetLastError );
				Sleep(100);
				continue;
			}
		}
	}

 
	//+---------------------------------------------------------------------------------------+
	//|       ,    .|
	//| ,  LocalTime()  > LastTradeTime + PauseBeforeTrade                      |
	//+---------------------------------------------------------------------------------------+
	while( true )
	{
		//     ,  
		if ( IsStopped() ) { Print( "   !" ); return(-1); }

		//   . 
		_LastTradeTime = GlobalVariableGet ( "LastTradeTime" );
		//     ,  ,  0,1     
		_GetLastError = GetLastError();
		if ( _GetLastError != 0 )
		{
			Print( "_PauseBeforeTrade() - GlobalVariableGet ( \"LastTradeTime\" ) - Error #", _GetLastError );
			continue;
		}

		// ,        
		RealPauseBeforeTrade = LocalTime() - _LastTradeTime;
		
		//   ,  PauseBeforeTrade ,
		if ( RealPauseBeforeTrade < PauseBeforeTrade )
		{
			//  ,  ,   
			Comment( "   .  ", PauseBeforeTrade - RealPauseBeforeTrade, " ." );
			Sleep(1000);
			continue;
		}
		//   ,  PauseBeforeTrade ,   
		else
		{ break; }
	}

	//+---------------------------------------------------------------------------------------+
	//|       ,    ,|
	//|    ,  LastTradeTime + PauseBeforeTrade							   |
	//|    LastTradeTime            |
	//+---------------------------------------------------------------------------------------+
	while( true )
	{
		//     ,  
		if ( IsStopped() ) { Print( "   !" ); return(-1); }

		//    LastTradeTime   .   - 
		if ( GlobalVariableSet( "LastTradeTime", LocalTime() ) > 0 ) { Comment( "" ); return(1); }
		else
		//  GlobalVariableSet   <= 0,   
		{
			_GetLastError = GetLastError();
			//  ,  0,1     
			if ( _GetLastError != 0 )
			{
				Print( "_PauseBeforeTrade() - GlobalVariableSet ( \"LastTradeTime\", ", LocalTime(), " ) - Error #", _GetLastError );
				Sleep(100);
				continue;
			}
		}
	}
}

//**************************************************************
//**************************************************************
//**************************************************************
//**************************************************************
//**************************************************************





